> For the complete documentation index, see [llms.txt](https://docs.veza.com/4yItIzMvkpAvMVFAamTf/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.veza.com/4yItIzMvkpAvMVFAamTf/developers/api/tags/promoted-tags.md).

# Promoted Tags

Operations for adding, removing, and listing tags for entity enrichment.

{% hint style="success" %}
Tag promotion for Access Reviews is currently available in Early Access. Please contact our support team to enable this capability.
{% endhint %}

Use these APIs to define the tags Veza should treat as customer-defined properties. Access Reviews that involve these entity types will include columns showing the tag name and value.

For example, in AWS, you may automatically tag identities with a 3rd-party security tool, or use tags to label S3 buckets containing sensitive data. When a tag is promoted, Veza Access Reviews will treat the tag as a built-in entity attribute, and show this information for reviewers in an optional column.

* [Promote tag](#promote-tag)
* [Demote tag](#demote-tag)
* [List tag promotions](#list-tag-promotions)

### Promote tag

Add a promotion rule by specifying its type and key, and the entity types it applies to:

* `include_entity_types`: if true, promote tags for the listed type(s).
* `exclude_entity_type`: if true, promotes tags for all entities **except** the listed type(s).

You can promote tags for any integration that supports them, such as Snowflake or Google Cloud. Use [Veza tags](/4yItIzMvkpAvMVFAamTf/developers/api/tags/tags-api.md) for integrations that do not support vendor-native tags or when built-in tagging is unavailable. Example tag types:

* `AWSTag`
* `CookieTag` (Veza Tag)
* `GoogleCloudLabel`

Entity types for tag promotion should be concrete types. You can confirm the format by viewing details for any graph node, and checking the *Type* attribute, for example:

* `OAA.PagerDuty.User`
* `ActiveDirectoryUser`
* `OAA.custom_idp.IDPUser`

{% openapi src="/files/Aco9gj4MY2XoNiD4zIjr" path="/api/preview/graph/tag\_promotions" method="post" %}
[openapi.yaml](https://1967633068-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-MZDkWMxox3pekd0NsZJ%2Fuploads%2Fgit-blob-c990b1c25368cfe24114b6d88a4d362095219709%2Fopenapi.yaml?alt=media)
{% endopenapi %}

### Demote tag

Remove a promotion rule for the specified tag key and type. Demotions apply on the next data source parse.

{% openapi src="/files/Aco9gj4MY2XoNiD4zIjr" path="/api/preview/graph/tag\_promotions:demote" method="post" %}
[openapi.yaml](https://1967633068-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-MZDkWMxox3pekd0NsZJ%2Fuploads%2Fgit-blob-c990b1c25368cfe24114b6d88a4d362095219709%2Fopenapi.yaml?alt=media)
{% endopenapi %}

### List tag promotions

Get all promotion rules for all entity types.

{% openapi src="/files/Aco9gj4MY2XoNiD4zIjr" path="/api/preview/graph/tag\_promotions" method="get" %}
[openapi.yaml](https://1967633068-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-MZDkWMxox3pekd0NsZJ%2Fuploads%2Fgit-blob-c990b1c25368cfe24114b6d88a4d362095219709%2Fopenapi.yaml?alt=media)
{% endopenapi %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.veza.com/4yItIzMvkpAvMVFAamTf/developers/api/tags/promoted-tags.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
